<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JP_FinalCustomerStaticData StructType
 * @subpackage Structs
 */
class JP_FinalCustomerStaticData extends AbstractStructBase
{
    /**
     * The Code
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $Code;
    /**
     * The Name
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * The Surname
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Surname;
    /**
     * The ContactData
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_FinalCustomerContactStaticData
     */
    public $ContactData;
    /**
     * The AddressData
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_FinalCustomerAddressStaticData
     */
    public $AddressData;
    /**
     * The Document
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_Document
     */
    public $Document;
    /**
     * The Url
     * @var string
     */
    public $Url;
    /**
     * The TimeStamp
     * @var string
     */
    public $TimeStamp;
    /**
     * The IntCode
     * @var string
     */
    public $IntCode;
    /**
     * Constructor method for JP_FinalCustomerStaticData
     * @uses JP_FinalCustomerStaticData::setCode()
     * @uses JP_FinalCustomerStaticData::setName()
     * @uses JP_FinalCustomerStaticData::setSurname()
     * @uses JP_FinalCustomerStaticData::setContactData()
     * @uses JP_FinalCustomerStaticData::setAddressData()
     * @uses JP_FinalCustomerStaticData::setDocument()
     * @uses JP_FinalCustomerStaticData::setUrl()
     * @uses JP_FinalCustomerStaticData::setTimeStamp()
     * @uses JP_FinalCustomerStaticData::setIntCode()
     * @param int $code
     * @param string $name
     * @param string $surname
     * @param \StructType\JP_FinalCustomerContactStaticData $contactData
     * @param \StructType\JP_FinalCustomerAddressStaticData $addressData
     * @param \StructType\JP_Document $document
     * @param string $url
     * @param string $timeStamp
     * @param string $intCode
     */
    public function __construct($code = null, $name = null, $surname = null, \StructType\JP_FinalCustomerContactStaticData $contactData = null, \StructType\JP_FinalCustomerAddressStaticData $addressData = null, \StructType\JP_Document $document = null, $url = null, $timeStamp = null, $intCode = null)
    {
        $this
            ->setCode($code)
            ->setName($name)
            ->setSurname($surname)
            ->setContactData($contactData)
            ->setAddressData($addressData)
            ->setDocument($document)
            ->setUrl($url)
            ->setTimeStamp($timeStamp)
            ->setIntCode($intCode);
    }
    /**
     * Get Code value
     * @return int
     */
    public function getCode()
    {
        return $this->Code;
    }
    /**
     * Set Code value
     * @param int $code
     * @return \StructType\JP_FinalCustomerStaticData
     */
    public function setCode($code = null)
    {
        // validation for constraint: int
        if (!is_null($code) && !is_numeric($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($code)), __LINE__);
        }
        $this->Code = $code;
        return $this;
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\JP_FinalCustomerStaticData
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get Surname value
     * @return string|null
     */
    public function getSurname()
    {
        return $this->Surname;
    }
    /**
     * Set Surname value
     * @param string $surname
     * @return \StructType\JP_FinalCustomerStaticData
     */
    public function setSurname($surname = null)
    {
        // validation for constraint: string
        if (!is_null($surname) && !is_string($surname)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($surname)), __LINE__);
        }
        $this->Surname = $surname;
        return $this;
    }
    /**
     * Get ContactData value
     * @return \StructType\JP_FinalCustomerContactStaticData|null
     */
    public function getContactData()
    {
        return $this->ContactData;
    }
    /**
     * Set ContactData value
     * @param \StructType\JP_FinalCustomerContactStaticData $contactData
     * @return \StructType\JP_FinalCustomerStaticData
     */
    public function setContactData(\StructType\JP_FinalCustomerContactStaticData $contactData = null)
    {
        $this->ContactData = $contactData;
        return $this;
    }
    /**
     * Get AddressData value
     * @return \StructType\JP_FinalCustomerAddressStaticData|null
     */
    public function getAddressData()
    {
        return $this->AddressData;
    }
    /**
     * Set AddressData value
     * @param \StructType\JP_FinalCustomerAddressStaticData $addressData
     * @return \StructType\JP_FinalCustomerStaticData
     */
    public function setAddressData(\StructType\JP_FinalCustomerAddressStaticData $addressData = null)
    {
        $this->AddressData = $addressData;
        return $this;
    }
    /**
     * Get Document value
     * @return \StructType\JP_Document|null
     */
    public function getDocument()
    {
        return $this->Document;
    }
    /**
     * Set Document value
     * @param \StructType\JP_Document $document
     * @return \StructType\JP_FinalCustomerStaticData
     */
    public function setDocument(\StructType\JP_Document $document = null)
    {
        $this->Document = $document;
        return $this;
    }
    /**
     * Get Url value
     * @return string|null
     */
    public function getUrl()
    {
        return $this->Url;
    }
    /**
     * Set Url value
     * @param string $url
     * @return \StructType\JP_FinalCustomerStaticData
     */
    public function setUrl($url = null)
    {
        // validation for constraint: string
        if (!is_null($url) && !is_string($url)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($url)), __LINE__);
        }
        $this->Url = $url;
        return $this;
    }
    /**
     * Get TimeStamp value
     * @return string|null
     */
    public function getTimeStamp()
    {
        return $this->TimeStamp;
    }
    /**
     * Set TimeStamp value
     * @param string $timeStamp
     * @return \StructType\JP_FinalCustomerStaticData
     */
    public function setTimeStamp($timeStamp = null)
    {
        // validation for constraint: string
        if (!is_null($timeStamp) && !is_string($timeStamp)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($timeStamp)), __LINE__);
        }
        $this->TimeStamp = $timeStamp;
        return $this;
    }
    /**
     * Get IntCode value
     * @return string|null
     */
    public function getIntCode()
    {
        return $this->IntCode;
    }
    /**
     * Set IntCode value
     * @param string $intCode
     * @return \StructType\JP_FinalCustomerStaticData
     */
    public function setIntCode($intCode = null)
    {
        // validation for constraint: string
        if (!is_null($intCode) && !is_string($intCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($intCode)), __LINE__);
        }
        $this->IntCode = $intCode;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\JP_FinalCustomerStaticData
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
